Index: branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90
===================================================================
--- branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90	(revision 15754)
+++ branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90	(revision 15764)
@@ -1549,5 +1918,5 @@
                   & )
 
-               CALL obs_rotvel( profdataqc(jtype), nn_2dint_default, zu, zv )
+               CALL obs_rotvel_pro( profdataqc(jtype), nn_2dint_default, zu, zv )
 
                DO jo = 1, profdataqc(jtype)%nprof
@@ -1582,4 +1951,23 @@
 
          DO jtype = 1, nsurftypes
+
+            IF ( TRIM(cobstypessurf(jtype)) == 'vel' ) THEN 
+               ! For velocity data, rotate the model velocities to N/S, E/W 
+               ! using the compressed data structure. 
+               ALLOCATE( & 
+                  & zu(surfdataqc(jtype)%nsurf), & 
+                  & zv(surfdataqc(jtype)%nsurf)  & 
+                  & ) 
+
+               CALL obs_rotvel_surf( surfdataqc(jtype), nn_2dint_default, zu, zv ) 
+
+               DO jo = 1, surfdataqc(jtype)%nsurf 
+                  surfdataqc(jtype)%rmod(jo,1) = zu(jo) 
+                  surfdataqc(jtype)%rmod(jo,2) = zv(jo) 
+               END DO 
+
+               DEALLOCATE( zu ) 
+               DEALLOCATE( zv ) 
+            END IF 
 
             CALL obs_surf_decompress( surfdataqc(jtype), &
Index: branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_level_search.h90
===================================================================
--- branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_level_search.h90	(revision 15754)
+++ branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_level_search.h90	(revision 15764)
@@ -13,5 +13,8 @@
       !! ** Method  : Straightforward search
       !!
-      !! ** Action  : 
+      !! ** Action  : Will return level associated with T-point below the obs 
+      !!              depth, except when observation is in the top box will  
+      !!              return level 2. Also, if obs depth greater than depth  
+      !!              of last wet T-point (kpk-1) will return level kpk.
       !!
       !! History :
@@ -43,6 +46,6 @@
       DO ji = 1, kobs 
          kobsk(ji) = 1
-         depk: DO jk = 2, kgrd
-            IF ( pgrddep(jk) >= pobsdep(ji) ) EXIT depk
+         depk: DO jk = 2, kgrd-1 
+            IF ( pgrddep(jk) > pobsdep(ji) ) EXIT depk
          END DO depk
          kobsk(ji) = jk
Index: branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_oper.F90
===================================================================
--- branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_oper.F90	(revision 15754)
+++ branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_oper.F90	(revision 15764)
@@ -37,4 +37,8 @@
    USE obs_grid,      ONLY : & 
       & obs_level_search     
+#if defined key_cice 
+   USE ice_constants, ONLY : &    ! For conversion from sea ice freeboard to thickness 
+      & rhos, rhoi, rhow 
+#endif
 
    IMPLICIT NONE
@@ -60,9 +64,9 @@
 
 
-   SUBROUTINE obs_prof_opt( prodatqc, kt, kpi, kpj, kpk, &
-      &                     kit000, kdaystp, kvar,       &
-      &                     pvar, pgdept, pgdepw,        &
-      &                     pmask,                       &  
-      &                     plam, pphi,                  &
+   SUBROUTINE obs_prof_opt( prodatqc, kt, kpi, kpj, kpk, & 
+      &                     kit000, kdaystp, kvar,       & 
+      &                     pvar, pclim,                 & 
+      &                     pgdept, pgdepw, pmask,       &   
+      &                     plam, pphi,                  & 
       &                     k1dint, k2dint, kdailyavtypes )
 
@@ -137,4 +141,5 @@
       REAL(KIND=wp), INTENT(IN), DIMENSION(kpi,kpj,kpk) :: &
          & pvar,   &                 ! Model field for variable
+         & pclim,  &                 ! Climatology field for variable
          & pmask                     ! Land-sea mask for variable
       REAL(KIND=wp), INTENT(IN), DIMENSION(kpi,kpj) :: &
@@ -172,5 +177,6 @@
       REAL(KIND=wp), DIMENSION(kpk) :: &
          & zobsk,    &
-         & zobs2k
+         & zobs2k,   & 
+         & zclm2k
       REAL(KIND=wp), DIMENSION(2,2,1) :: &
          & zweig1, &
@@ -178,4 +184,5 @@
       REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE :: &
          & zmask,  &
+         & zclim,  &
          & zint,   &
          & zinm,   &
@@ -187,4 +194,5 @@
       REAL(KIND=wp), DIMENSION(1) :: zmsk
       REAL(KIND=wp), DIMENSION(:,:,:), ALLOCATABLE :: interp_corner
+      REAL(KIND=wp), DIMENSION(:,:,:), ALLOCATABLE :: interp_corner_clim
 
       LOGICAL :: ld_dailyav
@@ -262,4 +270,6 @@
          & )
 
+      IF ( prodatqc%lclim ) ALLOCATE( zclim(2,2,kpk,ipro) )
+
       DO jobs = prodatqc%nprofup + 1, prodatqc%nprofup + ipro
          iobs = jobs - prodatqc%nprofup
@@ -285,4 +295,8 @@
       CALL obs_int_comm_3d( 2, 2, ipro, kpi, kpj, kpk, igrdi, igrdj, pgdept, zgdept ) 
       CALL obs_int_comm_3d( 2, 2, ipro, kpi, kpj, kpk, igrdi, igrdj, pgdepw, zgdepw ) 
+
+      IF ( prodatqc%lclim ) THEN 
+         CALL obs_int_comm_3d( 2, 2, ipro, kpi, kpj, kpk, igrdi, igrdj, pclim, zclim )             
+      ENDIF
 
       ! At the end of the day also get interpolated means
@@ -349,4 +363,5 @@
                   inum_obs = iend - ista + 1 
                   ALLOCATE(interp_corner(2,2,inum_obs),iv_indic(inum_obs)) 
+                  IF ( prodatqc%lclim ) ALLOCATE( interp_corner_clim(2,2,inum_obs) )
 
                   DO iin=1,2 
@@ -358,4 +373,11 @@
                               &     zobs2k, zgdept(iin,ijn,:,iobs), & 
                               &     zmask(iin,ijn,:,iobs)) 
+
+                           IF ( prodatqc%lclim ) THEN 
+                              CALL obs_int_z1d_spl( kpk, &  
+                                 &     zclim(iin,ijn,:,iobs), &  
+                                 &     zclm2k, zgdept(iin,ijn,:,iobs), &  
+                                 &     zmask(iin,ijn,:,iobs))  
+                           ENDIF
                         ENDIF 
        
@@ -372,4 +394,12 @@
                            &    zmask(iin,ijn,:,iobs)) 
        
+                        IF ( prodatqc%lclim ) THEN 
+                           CALL obs_int_z1d(kpk, iv_indic, k1dint, inum_obs, &  
+                              &    prodatqc%var(kvar)%vdep(ista:iend), &  
+                              &    zclim(iin,ijn,:,iobs), &  
+                              &    zclm2k, interp_corner_clim(iin,ijn,:), &  
+                              &    zgdept(iin,ijn,:,iobs), &  
+                              &    zmask(iin,ijn,:,iobs))  
+                        ENDIF
                      ENDDO 
                   ENDDO 
@@ -386,4 +416,5 @@
                inum_obs = iend - ista + 1 
                ALLOCATE(interp_corner(2,2,inum_obs), iv_indic(inum_obs)) 
+               IF ( prodatqc%lclim ) ALLOCATE( interp_corner_clim(2,2,inum_obs) )
                DO iin=1,2  
                   DO ijn=1,2 
@@ -395,4 +426,10 @@
                            &    zmask(iin,ijn,:,iobs)) 
   
+                        IF ( prodatqc%lclim ) THEN 
+                           CALL obs_int_z1d_spl( kpk, &  
+                              &    zclim(iin,ijn,:,iobs),&  
+                              &    zclm2k, zgdept(iin,ijn,:,iobs), &  
+                              &    zmask(iin,ijn,:,iobs))  
+                        ENDIF
                      ENDIF 
        
@@ -408,5 +445,13 @@
                          &          zgdept(iin,ijn,:,iobs),         & 
                          &          zmask(iin,ijn,:,iobs) )      
-         
+
+                     IF ( prodatqc%lclim ) THEN 
+                        CALL obs_int_z1d(kpk, iv_indic, k1dint, inum_obs,     &  
+                            &          prodatqc%var(kvar)%vdep(ista:iend),     &  
+                            &          zclim(iin,ijn,:,iobs),  &  
+                            &          zclm2k,interp_corner_clim(iin,ijn,:), &  
+                            &          zgdept(iin,ijn,:,iobs), &  
+                            &          zmask(iin,ijn,:,iobs) )    
+                     ENDIF
                   ENDDO 
                ENDDO 
@@ -451,4 +496,9 @@
                   &              prodatqc%var(kvar)%vmod(iend:iend) ) 
 
+               IF ( prodatqc%lclim ) THEN 
+                  CALL obs_int_h2d( 1, 1, zweig, interp_corner_clim(:,:,ikn), &  
+                     &              prodatqc%var(kvar)%vclm(iend:iend) ) 
+               ENDIF
+
                   ! Set QC flag for any observations found below the bottom
                   ! needed as the check here is more strict than that in obs_prep
@@ -458,4 +508,5 @@
  
             DEALLOCATE(interp_corner,iv_indic) 
+            IF ( prodatqc%lclim ) DEALLOCATE( interp_corner_clim )
           
          ENDIF
@@ -475,4 +526,6 @@
          & )
 
+      IF ( prodatqc%lclim ) DEALLOCATE( zclim )
+
       ! At the end of the day also get interpolated means
       IF ( ld_dailyav .AND. idayend == 0 ) THEN
@@ -486,8 +539,10 @@
    END SUBROUTINE obs_prof_opt
 
-   SUBROUTINE obs_surf_opt( surfdataqc, kt, kpi, kpj,            &
-      &                     kit000, kdaystp, psurf, psurfmask,   &
-      &                     k2dint, ldnightav, plamscl, pphiscl, &
-      &                     lindegrees )
+   SUBROUTINE obs_surf_opt( surfdataqc, kt, kpi, kpj, & 
+      &                     kit000, kdaystp, kvar, & 
+      &                     psurf, pclim, psurfmask, & 
+      &                     plam, pphi, & 
+      &                     k2dint, ldnightav, plamscl, pphiscl, & 
+      &                     lindegrees, kmeanstp )
 
       !!-----------------------------------------------------------------------
@@ -522,4 +577,5 @@
       !!      ! 15-02 (M. Martin) Combined routine for surface types
       !!      ! 17-03 (M. Martin) Added horizontal averaging options
+      !!      ! 20-08 (M. Martin) Added surface velocity options
       !!-----------------------------------------------------------------------
 
@@ -538,8 +594,16 @@
                                        !   (kit000-1 = restart time)
       INTEGER, INTENT(IN) :: kdaystp   ! Number of time steps per day
+      INTEGER, INTENT(IN) :: kvar      ! Number of variables in surfdataqc
       INTEGER, INTENT(IN) :: k2dint    ! Horizontal interpolation type (see header)
+      INTEGER, INTENT(IN), OPTIONAL :: & 
+                             kmeanstp  ! Number of time steps for the time meaning 
+                                       ! Averaging is triggered if present and greater than one
       REAL(wp), INTENT(IN), DIMENSION(kpi,kpj) :: &
          & psurf,  &                   ! Model surface field
+         & pclim,  &                   ! Climatological surface field
          & psurfmask                   ! Land-sea mask
+      REAL(KIND=wp), INTENT(IN), DIMENSION(kpi,kpj) :: &
+         & plam,   &                   ! Model longitudes for variable 
+         & pphi                        ! Model latitudes for variable
       LOGICAL, INTENT(IN) :: ldnightav ! Logical for averaging night-time data
       REAL(KIND=wp), INTENT(IN) :: &
@@ -559,4 +623,5 @@
       INTEGER :: imodi, imodj
       INTEGER :: idayend
+      INTEGER :: imeanend
       INTEGER, DIMENSION(:,:,:), ALLOCATABLE :: &
          & igrdi,   &
@@ -569,6 +634,7 @@
       REAL(wp) :: zlam
       REAL(wp) :: zphi
-      REAL(wp), DIMENSION(1) :: zext, zobsmask
+      REAL(wp), DIMENSION(1) :: zext, zobsmask, zclm
       REAL(wp) :: zdaystp
+      REAL(wp) :: zmeanstp
       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: &
          & zweig,  &
@@ -577,4 +643,5 @@
          & zsurfm, &
          & zsurftmp, &
+         & zclim,  &
          & zglam,  &
          & zgphi,  &
@@ -586,4 +653,6 @@
          & zouttmp, &
          & zmeanday    ! to compute model sst in region of 24h daylight (pole)
+
+      LOGICAL :: l_timemean
 
       !------------------------------------------------------------------------
@@ -594,4 +663,9 @@
       isurf = surfdataqc%nsstp(inrc)
 
+      l_timemean = .FALSE. 
+      IF ( PRESENT( kmeanstp ) ) THEN 
+         IF ( kmeanstp > 1 ) l_timemean = .TRUE. 
+      ENDIF
+
       ! Work out the maximum footprint size for the 
       ! interpolation/averaging in model grid-points - has to be even.
@@ -599,4 +673,40 @@
       CALL obs_max_fpsize( k2dint, plamscl, pphiscl, lindegrees, psurfmask, imaxifp, imaxjfp )
 
+      IF ( l_timemean ) THEN 
+         ! Initialize time mean for first timestep 
+         imeanend = MOD( kt - kit000 + 1, kmeanstp ) 
+         IF (lwp) WRITE(numout,*) 'Obs time mean ', kt, kit000, kmeanstp, imeanend 
+
+         ! Added kt == 0 test to catch restart case  
+         IF ( ( imeanend == 1 ) .OR. ( kt == 0 ) ) THEN 
+            IF (lwp) WRITE(numout,*) 'Reset surfdataqc%vdmean on time-step: ',kt 
+            DO jj = 1, jpj 
+               DO ji = 1, jpi 
+                  surfdataqc%vdmean(ji,jj,kvar) = 0.0 
+               END DO 
+            END DO 
+         ENDIF 
+
+         ! On each time-step, increment the field for computing time mean 
+         IF (lwp) WRITE(numout,*)'Accumulating surfdataqc%vdmean on time-step: ',kt 
+         DO jj = 1, jpj 
+            DO ji = 1, jpi 
+               surfdataqc%vdmean(ji,jj,kvar) = surfdataqc%vdmean(ji,jj,kvar) & 
+                  &                            + psurf(ji,jj) 
+            END DO 
+         END DO 
+
+         ! Compute the time mean at the end of time period 
+         IF ( imeanend == 0 ) THEN 
+            zmeanstp = 1.0 / REAL( kmeanstp ) 
+            IF (lwp) WRITE(numout,*)'Calculating surfdataqc%vdmean time mean on time-step: ',kt,' with weight: ',zmeanstp 
+            DO jj = 1, jpj 
+               DO ji = 1, jpi 
+                  surfdataqc%vdmean(ji,jj,kvar) = surfdataqc%vdmean(ji,jj,kvar) & 
+                     &                            * zmeanstp 
+               END DO 
+            END DO 
+         ENDIF 
+      ENDIF !l_timemean
 
       IF ( ldnightav ) THEN
@@ -665,17 +775,24 @@
 
       ALLOCATE( &
-         & zweig(imaxifp,imaxjfp,1),      &
-         & igrdi(imaxifp,imaxjfp,isurf), &
-         & igrdj(imaxifp,imaxjfp,isurf), &
-         & zglam(imaxifp,imaxjfp,isurf), &
-         & zgphi(imaxifp,imaxjfp,isurf), &
-         & zmask(imaxifp,imaxjfp,isurf), &
-         & zsurf(imaxifp,imaxjfp,isurf), &
-         & zsurftmp(imaxifp,imaxjfp,isurf),  &
-         & zglamf(imaxifp+1,imaxjfp+1,isurf), &
-         & zgphif(imaxifp+1,imaxjfp+1,isurf), &
-         & igrdip1(imaxifp+1,imaxjfp+1,isurf), &
-         & igrdjp1(imaxifp+1,imaxjfp+1,isurf) &
-         & )
+         & zweig(imaxifp,imaxjfp,1),       & 
+         & igrdi(imaxifp,imaxjfp,isurf),   & 
+         & igrdj(imaxifp,imaxjfp,isurf),   & 
+         & zglam(imaxifp,imaxjfp,isurf),   & 
+         & zgphi(imaxifp,imaxjfp,isurf),   & 
+         & zmask(imaxifp,imaxjfp,isurf),   & 
+         & zsurf(imaxifp,imaxjfp,isurf),   & 
+         & zsurftmp(imaxifp,imaxjfp,isurf) & 
+         & ) 
+
+      IF ( k2dint > 4 ) THEN 
+         ALLOCATE( & 
+            & zglamf(imaxifp+1,imaxjfp+1,isurf),  & 
+            & zgphif(imaxifp+1,imaxjfp+1,isurf),  & 
+            & igrdip1(imaxifp+1,imaxjfp+1,isurf), & 
+            & igrdjp1(imaxifp+1,imaxjfp+1,isurf)  & 
+            & ) 
+      ENDIF 
+      
+      IF ( surfdataqc%lclim ) ALLOCATE( zclim(imaxifp,imaxjfp,isurf) ) 
 
       DO jobs = surfdataqc%nsurfup + 1, surfdataqc%nsurfup + isurf
@@ -695,6 +812,8 @@
                IF ( imodj > jpjglo ) imodj = jpjglo
 
-               igrdip1(ji+1,jj+1,iobs) = imodi
-               igrdjp1(ji+1,jj+1,iobs) = imodj
+               IF ( k2dint > 4 ) THEN 
+                  igrdip1(ji+1,jj+1,iobs) = imodi 
+                  igrdjp1(ji+1,jj+1,iobs) = imodj 
+               ENDIF
                
                IF ( ji >= 1 .AND. jj >= 1 ) THEN
@@ -713,10 +832,29 @@
       CALL obs_int_comm_2d( imaxifp, imaxjfp, isurf, kpi, kpj, &
          &                  igrdi, igrdj, psurfmask, zmask )
-      CALL obs_int_comm_2d( imaxifp, imaxjfp, isurf, kpi, kpj, &
-         &                  igrdi, igrdj, psurf, zsurf )
-      CALL obs_int_comm_2d( imaxifp+1, imaxjfp+1, isurf, kpi, kpj, &
-         &                  igrdip1, igrdjp1, glamf, zglamf )
-      CALL obs_int_comm_2d( imaxifp+1, imaxjfp+1, isurf, kpi, kpj, &
-         &                  igrdip1, igrdjp1, gphif, zgphif )
+
+      ! At the end of the averaging period get interpolated means 
+      IF ( l_timemean ) THEN 
+         IF ( imeanend == 0 ) THEN 
+            ALLOCATE( zsurfm(imaxifp,imaxjfp,isurf) ) 
+            IF (lwp) WRITE(numout,*)' Interpolating the time mean values on time step: ',kt 
+            CALL obs_int_comm_2d( imaxifp, imaxjfp, isurf, kpi, kpj, & 
+               &                  igrdi, igrdj, surfdataqc%vdmean(:,:,kvar), zsurfm ) 
+         ENDIF 
+      ELSE 
+         CALL obs_int_comm_2d( imaxifp, imaxjfp, isurf, kpi, kpj, & 
+            &                  igrdi, igrdj, psurf, zsurf ) 
+      ENDIF 
+
+      IF ( k2dint > 4 ) THEN          
+         CALL obs_int_comm_2d( imaxifp+1, imaxjfp+1, isurf, kpi, kpj, & 
+            &                  igrdip1, igrdjp1, glamf, zglamf ) 
+         CALL obs_int_comm_2d( imaxifp+1, imaxjfp+1, isurf, kpi, kpj, & 
+            &                  igrdip1, igrdjp1, gphif, zgphif ) 
+      ENDIF
+
+      IF ( surfdataqc%lclim ) THEN  
+         CALL obs_int_comm_2d( imaxifp, imaxjfp, isurf, kpi, kpj, & 
+            &                  igrdi, igrdj, pclim, zclim ) 
+      ENDIF
 
       ! At the end of the day get interpolated means
@@ -758,48 +896,85 @@
          zphi = surfdataqc%rphi(jobs)
 
-         IF ( ldnightav .AND. idayend == 0 ) THEN
-            ! Night-time averaged data
-            zsurftmp(:,:,iobs) = zsurfm(:,:,iobs)
-         ELSE
-            zsurftmp(:,:,iobs) = zsurf(:,:,iobs)
+         IF (( ldnightav .AND. idayend == 0 ) .OR. (l_timemean .AND. imeanend == 0)) THEN 
+            ! Night-time or N=kmeanstp timestep averaged data 
+            zsurftmp(:,:,iobs) = zsurfm(:,:,iobs) 
+         ELSE 
+            zsurftmp(:,:,iobs) = zsurf(:,:,iobs) 
+         ENDIF 
+
+         IF (   ( .NOT. l_timemean ) .OR. &  
+             &  ( l_timemean .AND. imeanend == 0) ) THEN 
+            IF ( k2dint <= 4 ) THEN 
+
+               ! Get weights to interpolate the model value to the observation point 
+               CALL obs_int_h2d_init( 1, 1, k2dint, zlam, zphi,         & 
+                  &                   zglam(:,:,iobs), zgphi(:,:,iobs), & 
+                  &                   zmask(:,:,iobs), zweig, zobsmask ) 
+
+               ! Interpolate the model value to the observation point  
+               CALL obs_int_h2d( 1, 1, zweig, zsurftmp(:,:,iobs), zext ) 
+
+               IF ( surfdataqc%lclim ) THEN   
+                  CALL obs_int_h2d( 1, 1, zweig, zclim(:,:,iobs), zclm ) 
+               ENDIF 
+
+
+            ELSE 
+
+               ! Get weights to average the model SLA to the observation footprint 
+               CALL obs_avg_h2d_init( 1, 1, imaxifp, imaxjfp, k2dint, zlam,  zphi, & 
+                  &                   zglam(:,:,iobs), zgphi(:,:,iobs), & 
+                  &                   zglamf(:,:,iobs), zgphif(:,:,iobs), & 
+                  &                   zmask(:,:,iobs), plamscl, pphiscl, & 
+                  &                   lindegrees, zweig, zobsmask ) 
+
+               ! Average the model SST to the observation footprint 
+               CALL obs_avg_h2d( 1, 1, imaxifp, imaxjfp, & 
+                  &              zweig, zsurftmp(:,:,iobs), zext ) 
+
+               IF ( surfdataqc%lclim ) THEN   
+                  CALL obs_avg_h2d( 1, 1, imaxifp, imaxjfp, & 
+                     &              zweig, zclim(:,:,iobs), zclm ) 
+               ENDIF 
+
+            ENDIF 
+
+            IF ( TRIM(surfdataqc%cvars(1)) == 'SLA' .AND. surfdataqc%nextra == 2 ) THEN 
+               ! ... Remove the MDT from the SSH at the observation point to get the SLA 
+               surfdataqc%rext(jobs,1) = zext(1) 
+               surfdataqc%rmod(jobs,1) = surfdataqc%rext(jobs,1) - surfdataqc%rext(jobs,2) 
+            ELSE 
+               surfdataqc%rmod(jobs,kvar) = zext(1) 
+            ENDIF 
+
+            IF ( surfdataqc%lclim ) surfdataqc%rclm(jobs,1) = zclm(1) 
+
+            IF ( zext(1) == obfillflt ) THEN 
+               ! If the observation value is a fill value, set QC flag to bad 
+               surfdataqc%nqc(jobs) = 4 
+            ENDIF          
+         ENDIF 
+
+         IF ( surfdataqc%lclim ) surfdataqc%rclm(jobs,1) = zclm(1) 
+ 
+#if defined key_cice 
+         IF ( TRIM(surfdataqc%cvars(1)) == 'FBD' ) THEN 
+            ! Convert radar freeboard to true freeboard (add 1/4 snow depth; 1/4 based on ratio of speed of light in vacuum compared to snow (3.0e8 vs 2.4e8 m/s)) 
+            surfdataqc%rext(jobs,1) = surfdataqc%robs(jobs,1)  
+            surfdataqc%robs(jobs,1) = surfdataqc%rext(jobs,1) + 0.25*surfdataqc%rext(jobs,2) 
+            ! If the corrected freeboard observation is outside -0.3 to 3.0 m (CPOM) then set the QC flag to bad 
+            IF ((surfdataqc%robs(jobs,1) < -0.3) .OR. (surfdataqc%robs(jobs,1) > 3.0)) THEN 
+               surfdataqc%nqc(jobs) = 4 
+            ENDIF            
+            ! Convert corrected freeboard to ice thickness following Tilling et al. (2016) 
+            surfdataqc%robs(jobs,1) = (surfdataqc%robs(jobs,1)*rhow + surfdataqc%rext(jobs,2)*rhos)/ & 
+                                      (rhow - rhoi) 
          ENDIF
 
-         IF ( k2dint <= 4 ) THEN
-
-            ! Get weights to interpolate the model value to the observation point
-            CALL obs_int_h2d_init( 1, 1, k2dint, zlam, zphi,         &
-               &                   zglam(:,:,iobs), zgphi(:,:,iobs), &
-               &                   zmask(:,:,iobs), zweig, zobsmask )
-
-            ! Interpolate the model value to the observation point 
-            CALL obs_int_h2d( 1, 1, zweig, zsurftmp(:,:,iobs), zext )
-
-         ELSE
-
-            ! Get weights to average the model SLA to the observation footprint
-            CALL obs_avg_h2d_init( 1, 1, imaxifp, imaxjfp, k2dint, zlam,  zphi, &
-               &                   zglam(:,:,iobs), zgphi(:,:,iobs), &
-               &                   zglamf(:,:,iobs), zgphif(:,:,iobs), &
-               &                   zmask(:,:,iobs), plamscl, pphiscl, &
-               &                   lindegrees, zweig, zobsmask )
-
-            ! Average the model SST to the observation footprint
-            CALL obs_avg_h2d( 1, 1, imaxifp, imaxjfp, &
-               &              zweig, zsurftmp(:,:,iobs),  zext )
-
-         ENDIF
-
-         IF ( TRIM(surfdataqc%cvars(1)) == 'SLA' .AND. surfdataqc%nextra == 2 ) THEN
-            ! ... Remove the MDT from the SSH at the observation point to get the SLA
-            surfdataqc%rext(jobs,1) = zext(1)
-            surfdataqc%rmod(jobs,1) = surfdataqc%rext(jobs,1) - surfdataqc%rext(jobs,2)
-         ELSE
-            surfdataqc%rmod(jobs,1) = zext(1)
-         ENDIF
-         
-         IF ( zext(1) == obfillflt ) THEN
-            ! If the observation value is a fill value, set QC flag to bad
-            surfdataqc%nqc(jobs) = 4
-         ENDIF
+         IF ( zext(1) == obfillflt ) THEN 
+            ! If the observation value is a fill value, set QC flag to bad 
+            surfdataqc%nqc(jobs) = 4 
+         ENDIF 
+#endif defined key_cice
 
       END DO
@@ -814,19 +989,28 @@
          & zmask, &
          & zsurf, &
-         & zsurftmp, &
-         & zglamf, &
-         & zgphif, &
-         & igrdip1,&
-         & igrdjp1 &
+         & zsurftmp &
          & )
 
-      ! At the end of the day also deallocate night-time mean array
-      IF ( idayend == 0 .AND. ldnightav ) THEN
-         DEALLOCATE( &
-            & zsurfm  &
+      IF ( k2dint > 4 ) THEN 
+         DEALLOCATE( &      
+            & zglamf, & 
+            & zgphif, & 
+            & igrdip1,& 
+            & igrdjp1 & 
             & )
       ENDIF
 
-      surfdataqc%nsurfup = surfdataqc%nsurfup + isurf
+      IF ( surfdataqc%lclim ) DEALLOCATE( zclim ) 
+
+      ! At the end of the day also deallocate night-time mean array 
+      IF (( idayend == 0 .AND. ldnightav ) .OR. ( imeanend == 0 .AND. l_timemean )) THEN
+         DEALLOCATE( & 
+            & zsurfm  & 
+            & ) 
+      ENDIF
+
+      IF ( kvar == surfdataqc%nvar ) THEN 
+         surfdataqc%nsurfup = surfdataqc%nsurfup + isurf 
+      ENDIF
 
    END SUBROUTINE obs_surf_opt
